// C Source File
// Created 27/07/2003; 12:16:00

#include "mkcomplib.h"

/*===============================================================================================
== creation of the tree (make its nodes) with the stats
=================================================================================================
== stat : table of filled stats
== NODE : table of nodes to fill
=================================================================================================
== return the root position
===============================================================================================*/
void mk_tree(unsigned short stat[], TREE tree[], unsigned short nL) {

  short i;
  unsigned short j=0;
  unsigned short min1;  //value of the second minimum
  unsigned short min2;  //value of the second minimum
  unsigned short pos_min1=0;  //the positions
  unsigned short pos_min2=0;
  short no_node=0;  //first node
  unsigned short freq[512];
  
  memset(freq,0,512*sizeof(short));
  memset(tree,0,nL*sizeof(TREE));

  for (j=0;j<256;j++)
    freq[j]=stat[j];
  
  // search the two smallest freq
  // 0 < min1 <= min2
  // if min1==min2 : pos_min1 < pos_min2
  
  for (j=0;j<nL-1;j++) {
    min1=65535;
    min2=65535;
    for (i=0;i<256+no_node;i++) {  //on every existing node, 
      if (freq[i]!=0 && freq[i]<min1) {  //take the smaller
        if (freq[i]<min2) { //it's the smallest
          min1=min2;
          pos_min1=pos_min2;
          min2=freq[i];
          pos_min2=i;
        } else {  //it's the second minimum
          min1=freq[i];
          pos_min1=i;
        }
      }
    }
    freq[256+no_node]=min1+min2;
    if (pos_min1>255) {//it's a node
      tree[no_node].right_branch=pos_min1-256;
      tree[no_node].node_right=1;
      tree[pos_min1-256].node=1;
      tree[pos_min1-256].father=no_node;
    } else { //it's a caracter
      tree[no_node].right_branch=pos_min1;
      tree[no_node].node_right=0;
    }
    if (pos_min2>255) {//it's a node
      tree[no_node].left_branch=pos_min2-256;
      tree[no_node].node_left=1;
      tree[pos_min2-256].node=0;
      tree[pos_min2-256].father=no_node;
    } else { //it's a caracter
      tree[no_node].left_branch=pos_min2;
      tree[no_node].node_left=0;
    }
    freq[pos_min1]=0;
    freq[pos_min2]=0;
    no_node++;
  }
  tree[no_node-1].father=0;
//disp("\n nb node=%d",no_node)
}
