// C Source File
// Created 27/07/2003; 11:59:25

#include "mkcomplib.h"

/*===============================================================================================
== Komp decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
void decomp_stat(unsigned char * data, unsigned short stat[]) {

  short i;
  unsigned char * n=NULL;
  unsigned char * limite;

  if (*data != 0) {  //quel est le mode... 1 ou 2
    for (i=0;i<256;i++)
      stat[i]=data[(*data)*i+1]+( *data==2 ? 256*data[(*data)*i+2] : 0 );  //no caract=(*stat)*i   //copie du nb de caract (les deux octets !!)
  } else {  //mode "mix"
    limite=data+3+3*data[1];  //nombre de caract nombreux
    for (n=data+3;n<limite;n+=3)  //copie des nombreux
      stat[*n]=256*(*(n+1))+(*(n+2));
    for (n=limite;n<limite+2*data[2];n+=2)  //copie des peu nombreux
      stat[*n]=*(n+1);
  }

}

/*===============================================================================================
== Komp decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr study_dkomp(unsigned char * data, unsigned short length,
                    TREE * * tree, unsigned short * file_len, unsigned short * nL) {

  unsigned short * stat;
  unsigned short i;
  
  if (strcmp(&(data[length-4]),"KOMP")==0 && data[3]<3)
    return COMP_ERR_NOT_A_COMP;
  
  *file_len=*(unsigned short *)data;
  data+=3;
  
  stat=(unsigned short *)malloc(512*sizeof(unsigned short));
  if (stat==NULL)
    return COMP_ERR_MEM;
  memset(stat,0,512*sizeof(unsigned short));

  decomp_stat(data,stat);

  for (i=0;i<256;i++)
    if (stat[i]!=0)
      (*nL)++;  //count the differents caracter

  *tree=malloc((*nL)*sizeof(TREE));
  if (*tree==NULL) {
    free(stat);
    return COMP_ERR_MEM;
  }

  mk_tree(stat,*tree,*nL);
  
  free(stat); 

  return COMP_NO_ERR;
}

/*===============================================================================================
== Komp decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr mk_dkomp(unsigned char * data, unsigned char * dest, const unsigned char * str_tag, unsigned char tag_length, TREE * tree, unsigned short file_len, unsigned short nL) {

  unsigned char * data_comp;
  unsigned char * dest_tag;

  data_comp=data+3+1+256*(*data)+((*data)==0)*(3*data[1]+2*data[2]+2);

  dest_tag=write_decomp(data_comp,file_len-1,dest+2,tree,0,nL-2);

  *(unsigned short *)dest=file_len;
  if (tag_length==0) {
    dest[file_len+1]=*(data-1);  //copy of the type
  } else {
    for (nL=0;nL<tag_length;nL++) //copy of the personnalised tag for the decompression data -> var
      *(dest_tag++)=*(str_tag++);
  }
  free(tree);

  return COMP_NO_ERR;
}

