// C Source File
// Created 27/07/2003; 12:02:40

#include "mkcomplib.h"

/*===============================================================================================
== Komp decompression of datas in a variables
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== name_var_dest : name of the variable where the compressed datas will be stored
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the hsym structure created, else HS_NULL
===============================================================================================*/

HSym dkomp_data_hsym(unsigned char * data, unsigned short length, const unsigned char * name_var_dest, const unsigned char * str_tag, unsigned char tag_length, CompErr * error) {

  TREE * tree=NULL;
  unsigned short file_len;
  unsigned short nL;

  HANDLE h;
  unsigned char * dest;

  *error=study_dkomp(data,length,&tree,&file_len,&nL);
  
  if (error!=COMP_NO_ERR)
    return HS_NULL;

  h=HeapAlloc(file_len+2);
  if (h==H_NULL) {
    free(tree);
    *error=COMP_ERR_MEM;
    return HS_NULL;
  }
  dest=HLock(h);
  
  *error=mk_dkomp(data,dest,str_tag,tag_length,tree,file_len,nL);

  if (error!=COMP_NO_ERR) {
  	HeapFree(h);
    return HS_NULL;
  }
  
  HeapUnlock(h);  

  return mk_var(HS_NULL,name_var_dest,h,error);
}

