// C Source File
// Created 07/02/2004; 18:25:53

#include "mkcomptest.h"

long memini;

void print_mem(const unsigned char * text) {
  long mem=HeapAvail();
  printf("\n%s: ini=%ld     actu=%ld    diff=%ld",text,memini,mem,memini-mem);  
}


/*===============================================================================================
== test
===============================================================================================*/
void teststat(void) {
  unsigned char datas[]="aaaaaaabbbbbbbbbbbbbbbbbbbbc";
  unsigned short nL;
  unsigned short stat[256];
  
  nL=mk_stat(stat,datas,strlen(datas));
  
  clrscr();
  printf("nl=%d\n",nL);
  printf("stat a:%d\nstat b:%d\nstat c:%d",stat['a'],stat['b'],stat['c']);
  ngetchx();
  
}

/*===============================================================================================
== test
===============================================================================================*/
void testmktree(void) {
  unsigned char datas[]="aaaaaaabbbbbbbbbbbbbbbbbbbbc";
//  unsigned char datas[]="aaaaabb";
  unsigned short nL;
  unsigned short stat[256];
  TREE tree[256];
  unsigned short no;
  
  nL=mk_stat(stat,datas,strlen(datas));
	mk_tree(stat,tree,nL);
	
	clrscr();
	no=0;
	while ( no!=nL-1 ) {
		printf("\n %d : %d(%d) %d(%d) - %d : %d",no,tree[no].right_branch,tree[no].node_right,
						tree[no].left_branch,tree[no].node_left,tree[no].father,tree[no].node);
    if (no+1%8==0)
      ngetchx();
    no++;
  }
  ngetchx();
  
}

/*===============================================================================================
== test
===============================================================================================*/
void testevallen(void) {
  unsigned char datas[]="aaaaaaabbbbbbbbbbbbbbbbbbbbc";
  unsigned short nL;
  unsigned short stat[256];
  TREE tree[256];
  unsigned long l;
  
	clrscr();
  nL=mk_stat(stat,datas,strlen(datas));
	mk_tree(stat,tree,nL);
  l=eval_len(tree,nL,stat);
	
  printf("len=%ld",l);
  ngetchx();
  
}



/*===============================================================================================
== test
===============================================================================================*/
void testwritecomp(void) {
  unsigned char datas1[]="aaaaabbbbbbbbbbbbbbbbbbbbc";
  unsigned char datas2[]="aaaaaaabbbbbbbbbbbbbbbbbbbbc";
  short nL;
  unsigned short stat[256];
  TREE tree[256];
  short i,j;
  char err;
  long l;
  unsigned char buffer[10];
  short offset;
  
  clrscr();
  nL=mk_stat(stat,datas1,strlen(datas1));
  mk_tree(stat,tree,nL);
  l=eval_len(tree,nL,stat);
  
  offset=l&0x07;  //number of bit that "overflow"
  l>>=3;  //get the length in byte
  l-=(offset==0);
  if (--offset<0)
    offset=7;
	err=write_comp(datas1,strlen(datas1),tree,buffer+l,offset);
  
  printf("err=%d\ncomp=",err);
  for (i=0;i<l+(offset!=0);i++) {
    for (j=0;j<8;j++) {
      printf("%d",((buffer[i]&(1<<j))!=0));
    }
    printf (" %d\n",buffer[i]);
  }
  ngetchx();

  clrscr();
  nL=mk_stat(stat,datas2,strlen(datas2));
  mk_tree(stat,tree,nL);
  l=eval_len(tree,nL,stat);
  
  offset=l&0x07;  //number of bit that "overflow"
  l>>=3;  //get the length in byte
  l-=(offset==0);
  if (--offset<0)
    offset=7;
	err=write_comp(datas2,strlen(datas2),tree,buffer+l,offset);
  
  printf("err=%d\ncomp=",err);
  for (i=0;i<l+(offset!=0);i++) {
    for (j=0;j<8;j++) {
      printf("%d",((buffer[i]&(1<<j))!=0));
    }
    printf (" %d\n",buffer[i]);
  }
  ngetchx();
  
}

/*===============================================================================================
== call the tests
===============================================================================================*/
void testhuffman(void) {

//  teststat();
//  testmktree();
//  testevallen();
  testwritecomp();
 
}

